package manas.GGates;

import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.AttributeMap;
import org.jgraph.graph.GraphConstants;
import org.jgraph.graph.GraphModel;
import org.jgraph.JGraph;

import javax.swing.tree.MutableTreeNode;
import javax.swing.*;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Point2D;
import java.awt.*;
import java.util.Map;
import java.util.Hashtable;
import java.util.ArrayList;
import java.util.Iterator;

import manas.gui.DesignFrame;
import manas.MGates.MOr;
import manas.MGates.MWire;

/**
 * Created by IntelliJ IDEA.
 * User: pc
 * Date: 22.Nis.2006
 * Time: 21:20:58
 * To change this template use File | Settings | File Templates.
 */
public class GOr extends DefaultGraphCell implements Simulation
{
    private boolean isVisited;
    private MOr simulatorOr;
    private MWire inWire1, inWire2, outWire;
    JGraph graph;
    GraphModel model;

    public boolean isVisited() {
        return isVisited;
    }

    public void setVisited(boolean visited) {
        isVisited = visited;
    }

    public void push(int index, MWire deger) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public MWire pop(int index) {
        return null;  //To change body of implemented methods use File | Settings | File Templates.
    }

    protected static ImageIcon CreateImageIcon(String path) {
            java.net.URL imgURL = DesignFrame.class.getResource(path);
            if (imgURL != null) {
                return new ImageIcon(imgURL);
            } else {
                System.err.println("Couldn't find file: " + path);
                    return null;
            }
        }

    public Map createCellAttributes(Point2D point, String path)
    {
        Map map = new Hashtable();
        ImageIcon icon = null;
/*    String iconPath = "images/andgate_small.gif";
    URL jgraphUrl = MainFrame.class.getClassLoader()
                            .getResource(iconPath);
    if(jgraphUrl == null) System.out.println("icon yok");
    icon = new ImageIcon(jgraphUrl);*/
        icon = CreateImageIcon(path);
        GraphConstants.setBounds(map, new Rectangle2D.Double(point.getX(), point.getY(), 20, 20));
        GraphConstants.setResize(map, true);
        GraphConstants.setSizeable(map, false);
        GraphConstants.setSelectable(map, true);
        GraphConstants.setEditable(map, false);
        GraphConstants.setIcon(map, icon);
        return map;
        }

    public GOr(JGraph graph) {
        this.graph = graph;
        model = graph.getModel();
        init();
    }

    public GOr(Object userObject) {
        super(userObject);
        init();
    }

    public GOr(Object userObject, AttributeMap storageMap) {
        super(userObject, storageMap);
        init();
    }

    public GOr(Object userObject, AttributeMap storageMap, MutableTreeNode[] children) {
        super(userObject, storageMap, children);
        init();
    }

    private void init()
    {
       // GraphConstants.setBounds(this.getAttributes(), new Rectangle2D.Double(30, 30, 50, 30));
        //this.addPort(new Point2D.Double(100,100));
         getAttributes().applyMap(createCellAttributes(new Point(10, 10),"images/orgate.gif"));

       // GraphConstants.setBounds(this.getAttributes(), new Rectangle2D.Double(30, 30, 50, 30));
          /*  this.addPort(new Point(0,250));
            this.addPort(new Point(0,750));
            this.addPort(new Point(1000,500));
            */
        InPort ip1 = new InPort();
        InPort ip2 = new InPort();
        OutPort op = new OutPort();
        GraphConstants.setOffset(ip1.getAttributes(), new Point(0, 250));
        GraphConstants.setOffset(ip2.getAttributes(), new Point(0, 750));
        GraphConstants.setOffset(op.getAttributes(), new Point(1000,500));
        this.add(ip1);
        this.add(ip2);
        this.add(op);

        isVisited = false;
        inWire1 = new MWire();
        inWire2 = new MWire();
        outWire = new MWire();
        inWire1.addWire(0);
        inWire2.addWire(0);
        outWire.addWire(0);

        simulatorOr = new MOr();
    }

    public MWire simulate() {
        MWire teller[] = new MWire[2];
        int s = 0;
        java.util.List listEdges = new ArrayList();
        teller[0] = inWire1;
        teller[1] = inWire2;
        int numChildren = model.getChildCount(this);
        for (int i = 0; i < numChildren; i++) {
            Object port = model.getChild(this, i);

            if (port instanceof InPort) {
                Iterator iter = model.edges(port);
                if(iter.hasNext())
                {
                    Object edge = iter.next();
                    Simulation vertex = (Simulation)getSourceVertex(edge);
                    teller[s++] = vertex.simulate();
                    //System.out.println("And output = " + teller[s-1].getWire(0));
                } else teller[s++].setwire(0, 0);
//TODO: buradaki input portuna kac tane edge baglidir diye kontrol edilecek ve
//TODO: output portlarindan kac tane baglidir diye hata kontrolu yaplacak
/*
                while (iter.hasNext()) {
                    listEdges.add(iter.next());
                }
*/
            }
        }

        inWire1.setwire(0, teller[0].getWire(0));
        inWire2.setwire(0, teller[1].getWire(0));
        simulatorOr.addWire(inWire1);
        simulatorOr.addWire(inWire2);
        outWire = simulatorOr.run();
//        System.out.println(teller[0].getWire(0) + " ----- " + teller[1].getWire(0) + " ====== " + outWire.getWire(0));
        if(isVisited == false)
        {
            System.out.println("GNot a girdi");
            isVisited = true;
        }
        return outWire;  //To change body of implemented methods use File | Settings | File Templates.
    }

    private Object getSourceVertex(Object edge)
    {
        Object vertex = null;
        if(model.getSource(edge) instanceof OutPort) vertex = model.getParent(model.getSource(edge));
        else vertex = model.getParent(model.getTarget(edge));
        return vertex;
    }

    public void setInWire1(MWire inWire1) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setInWire2(MWire inWire2) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public MWire getOutWire() {
        return null;  //To change body of implemented methods use File | Settings | File Templates.
    }
}

