package manas.GGates;

import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.AttributeMap;
import org.jgraph.graph.GraphConstants;

import javax.swing.tree.MutableTreeNode;
import javax.swing.*;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Point2D;
import java.awt.*;
import java.util.Map;
import java.util.Hashtable;

import manas.gui.DesignFrame;

/**
 * Created by IntelliJ IDEA.
 * User: pc
 * Date: 22.Nis.2006
 * Time: 21:31:28
 * To change this template use File | Settings | File Templates.
 */
public class Gwire extends DefaultGraphCell
{
    private boolean isVisited;

    public boolean isVisited() {
        return isVisited;
    }

    public void setVisited(boolean visited) {
        isVisited = visited;
    }

    protected static ImageIcon CreateImageIcon(String path) {
            java.net.URL imgURL = DesignFrame.class.getResource(path);
            if (imgURL != null) {
                return new ImageIcon(imgURL);
            } else {
                System.err.println("Couldn't find file: " + path);
                    return null;
            }
        }

    public Map createCellAttributes(Point2D point, String path)
    {
        Map map = new Hashtable();
        ImageIcon icon = null;
/*    String iconPath = "images/andgate_small.gif";
    URL jgraphUrl = MainFrame.class.getClassLoader()
                            .getResource(iconPath);
    if(jgraphUrl == null) System.out.println("icon yok");
    icon = new ImageIcon(jgraphUrl);*/
        icon = CreateImageIcon(path);
        GraphConstants.setBounds(map, new Rectangle2D.Double(point.getX(), point.getY(), 20, 20));
        GraphConstants.setResize(map, true);
        GraphConstants.setSizeable(map, false);
        GraphConstants.setSelectable(map, true);
        GraphConstants.setEditable(map, false);
        GraphConstants.setIcon(map, icon);
        return map;
        }

    public Gwire() {
        init();
    }

    public Gwire(Object userObject) {
        super(userObject);
        init();
    }

    public Gwire(Object userObject, AttributeMap storageMap) {
        super(userObject, storageMap);
        init();
    }

    public Gwire(Object userObject, AttributeMap storageMap, MutableTreeNode[] children) {
        super(userObject, storageMap, children);
        init();
    }

    private void init()
    {
         // GraphConstants.setBounds(this.getAttributes(), new Rectangle2D.Double(30, 30, 50, 30));
        //this.addPort(new Point2D.Double(100,100));
         getAttributes().applyMap(createCellAttributes(new Point(10, 10),"images/wire.gif"));

       // GraphConstants.setBounds(this.getAttributes(), new Rectangle2D.Double(30, 30, 50, 30));
        this.addPort(new Point2D.Double(20,20));
    }
}