package manas.event;

import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.JGraph;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.geom.Point2D;
import java.awt.*;
import java.util.Map;
import java.util.Hashtable;

import manas.GGates.GLed;
import manas.GGates.GNor;

/**
 * Created by IntelliJ IDEA.
 * User: pc
 * Date: 23.Mar.2006
 * Time: 20:47:49
 * To change this template use File | Settings | File Templates.
 */
public class AddNorAction extends AbstractAction {
    JGraph graph;

    public AddNorAction(JGraph graph) {
        this.graph = graph;
    }

    public void actionPerformed(ActionEvent e) {
        //To change body of implemented methods use File | Settings | File Templates.
        insert(new Point(30, 30));
    }

    // Insert a new Vertex at point
    public void insert(Point2D point) {
        // Construct Vertex with no Label
        DefaultGraphCell vertex = createDefaultGraphCell();
        // Create a Map that holds the attributes for the Vertex
        //vertex.getAttributes().applyMap(createCellAttributes(point));
        // Insert the Vertex (including child port and attributes)
        graph.getGraphLayoutCache().insert(vertex);
    }

    // Hook for subclassers
    public Map createCellAttributes(Point2D point) {
        Map map = new Hashtable();
        // Snap the Point to the Grid
        point = graph.snap((Point2D) point.clone());
        // Add a Bounds Attribute to the Map
        //GraphConstants.setBounds(map, new Rectangle2D.Double(point.getX(),
        //        point.getY(), 0, 0));
        // Make sure the cell is resized on insert
        //GraphConstants.setResize(map, false);
        // Add a nice looking gradient background
        //GraphConstants.setGradientColor(map, Color.blue);
        // Add a Border Color Attribute to the Map
        //GraphConstants.setBorderColor(map, Color.black);
        // Add a White Background
        //GraphConstants.setBackground(map, Color.white);
        // Make Vertex Opaque
        //GraphConstants.setOpaque(map, true);
        return map;
    }

    public JGraph getGraph() {
        return graph;
    }

    public void setGraph(JGraph graph) {
        this.graph = graph;
    }

    // Hook for subclassers
    protected DefaultGraphCell createDefaultGraphCell() {
       GNor cell = new GNor(graph);
        //DefaultGraphCell cell = new DefaultGraphCell("Cell "
        //		+ new Integer(cellCount++));
        // Add one Floating Port
        //cell.add(new DefaultPort());
        return cell;
    }
}