package manas.event;

import javax.swing.*;
import javax.swing.filechooser.FileFilter;
import javax.imageio.ImageIO;
import java.awt.event.ActionEvent;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.*;


import org.jgraph.JGraph;
import java.lang.String;


/**
 * Created by IntelliJ IDEA.
 * User: Serhat
 * Date: 27.Nis.2006
 * Time: 02:56:49
 * To change this template use File | Settings | File Templates.
 */
public class PrintJPEGDrawAction extends AbstractAction {
    private JGraph   designInternalFrame1 ;

    public PrintJPEGDrawAction(JGraph designInternalFrame)
    {
        this.designInternalFrame1 = designInternalFrame;
    }

    public void actionPerformed(ActionEvent e) {
     try{

        JFileChooser chooser = new JFileChooser();
        FileFilter filter = new javax.swing.filechooser.FileFilter() {
            public boolean accept(File f) {
                        return f.isDirectory() || f.getName().toLowerCase().endsWith(".jpeg");
                    }
            public String getDescription() {
                        return "JPEG file";
                    }
        };

        chooser.setFileFilter(filter);

        int returnVal = chooser.showSaveDialog(null);

        if(returnVal == JFileChooser.APPROVE_OPTION)
        {
         //   String filename = chooser.getSelectedFile().getName();
            String path = chooser.getSelectedFile().getAbsolutePath() + ".jpeg";

            FileOutputStream fos = new FileOutputStream(path);
            Color bg = designInternalFrame1.getBackground();
            BufferedImage img = designInternalFrame1.getImage(bg, 40);
            ImageIO.write(img, "jpeg", fos);
            fos.flush();
            fos.close();
        }
      } catch ( Exception ex ){
            ex.printStackTrace();
      }
    }
}