package manas.simulation;

import org.jgraph.JGraph;
import org.jgraph.graph.DefaultGraphCell;

import java.util.Vector;
import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;

import manas.MGates.MSuper;
import manas.GGates.Simulation;

/**
 * Created by IntelliJ IDEA.
 * User: SahinBey
 * Date: 25.Nis.2006
 * Time: 13:23:37
 * To change this template use File | Settings | File Templates.
 */
public class Simulate implements Runnable {
    JGraph graph;
    Vector<MSuper> devre;
    Mapper mapper;
    Vector<int[]> elementIndices = new Vector<int[]>();
    CircuitSplitter circuitSplitter;
    ArrayList rootList;

    public void run() {
        //To change body of implemented methods use File | Settings | File Templates.
        try{
            while(true)
            {
                elementIndices = circuitSplitter.extractAllCircuits();
                for (int i = 0; i < elementIndices.size(); i++) {
                    int[] ints = elementIndices.elementAt(i);
                    rootList = mapper.findRoots(graph.getModel().getRootAt(ints[0]));
                    //System.out.println("run -> for");
                    for(int a = 0; a < rootList.size(); a++)
                    {

                        Simulation sm = (Simulation)rootList.get(a);
                        sm.simulate();
                    }
                }
                graph.getGraphLayoutCache().refresh(graph.getGraphLayoutCache().getCellViews(), true);
                graph.repaint();
                Thread.sleep(100);
            }
        } catch(InterruptedException ie) {
            System.out.println("Interrupt exceptio...");
        }

    }

    public Simulate(JGraph graph, Vector<MSuper> devre) {
        this.graph = graph;
        this.devre = devre;
        mapper = new Mapper(graph, elementIndices);
        circuitSplitter = new CircuitSplitter(graph);
    }
}
