package manas.GGates;

import org.jgraph.graph.*;
import org.jgraph.JGraph;

import javax.swing.tree.MutableTreeNode;
import javax.swing.*;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Point2D;
import java.awt.*;
import java.util.Map;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

import manas.gui.DesignFrame;
import manas.MGates.MWire;

/**
 * Created by IntelliJ IDEA.
 * User: pc
 * Date: 22.Nis.2006
 * Time: 21:34:50
 * To change this template use File | Settings | File Templates.
 */
public class GLed extends DefaultGraphCell implements Simulation
{
    //private static int state;
    private int state = 0;
    private boolean isVisited;
    private MWire inWire1;
    private JGraph graph;
    private GraphModel model;
    ImageIcon icon = null;

     protected static ImageIcon CreateImageIcon(String path) {
            java.net.URL imgURL = DesignFrame.class.getResource(path);
            if (imgURL != null) {
                return new ImageIcon(imgURL);
            } else {
                System.err.println("Couldn't find file: " + path);
                    return null;
            }
        }

    public Map createCellAttributes(Point2D point, String path)
    {
        Map map = new Hashtable();
        ImageIcon icon = null;
/*    String iconPath = "images/andgate_small.gif";
    URL jgraphUrl = MainFrame.class.getClassLoader()
                            .getResource(iconPath);
    if(jgraphUrl == null) System.out.println("icon yok");
    icon = new ImageIcon(jgraphUrl);*/
        icon = CreateImageIcon(path);
        GraphConstants.setBounds(map, new Rectangle2D.Double(point.getX(), point.getY(), 20, 20));
        GraphConstants.setResize(map, true);
        GraphConstants.setSizeable(map, false);
        GraphConstants.setSelectable(map, true);
        GraphConstants.setEditable(map, false);
        GraphConstants.setIcon(map, icon);
        return map;
        }

    public GLed(JGraph jg) {
        graph = jg;
        model = graph.getModel();
        init();
    }

    public GLed(Object userObject) {
        super(userObject);
        init();
    }

    public GLed(Object userObject, AttributeMap storageMap) {
        super(userObject, storageMap);
        init();
    }

    public GLed(Object userObject, AttributeMap storageMap, MutableTreeNode[] children) {
        super(userObject, storageMap, children);
        init();
    }

    private void init()
    {
        getAttributes().applyMap(createCellAttributes(new Point(10, 10),"images/led.gif"));

       // GraphConstants.setBounds(this.getAttributes(), new Rectangle2D.Double(30, 30, 50, 30));
       //this.addPort(new Point(150,500));
        InPort ip = new InPort();
        GraphConstants.setOffset(ip.getAttributes(), new Point(150, 500));
        this.add(ip);

        inWire1 = new MWire();
        inWire1.addWire(0);
        isVisited = false;
    }

    public boolean isVisited() {
        return isVisited;
    }

    public void setVisited(boolean visited) {
        isVisited = visited;
    }

    public void push(int index, MWire deger) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public MWire pop(int index) {
        return null;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public MWire simulate() {
        Simulation vertex;

        List listEdges = new ArrayList();
                //new ArrayList();
        int numChildren = model.getChildCount(this);

        for (int i = 0; i < numChildren; i++) {
            Object port = model.getChild(this, i);
//            if (model.isPort(port)) {

            if (port instanceof InPort) {
                Iterator iter = model.edges(port);

                while (iter.hasNext()) {
                    listEdges.add(iter.next());
                }
            }
        }
        if(listEdges.size() == 0) inWire1.setwire(0, 0);
        else {

            vertex = (Simulation)getSourceVertex(listEdges.get(0));
            inWire1 = vertex.simulate();
            state = inWire1.getWire(0);
            if(state == 0) {
                //System.out.println("led state = 0");
                icon = CreateImageIcon("images/led.gif");
            }
            else {
                //System.out.println("led state = 1");
                icon = CreateImageIcon("images/led1.gif");
            }
            GraphConstants.setIcon(this.getAttributes(), icon);
            graph.getGraphLayoutCache().refresh(graph.getGraphLayoutCache().getCellViews(), true);
        }
        if(isVisited == false)
        {
            System.out.println("GLed e girdi");
            isVisited = true;
        }
        return inWire1;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setInWire1(MWire inWire1) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setInWire2(MWire inWire2) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public MWire getOutWire() {
        return null;  //To change body of implemented methods use File | Settings | File Templates.
    }

    private Object getSourceVertex(Object edge)
    {
        Object vertex = null;
        if(model.getSource(edge) instanceof OutPort) vertex = model.getParent(model.getSource(edge));
        else vertex = model.getParent(model.getTarget(edge));
        return vertex;
    }
}

