package manas.GGates;

import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.AttributeMap;
import org.jgraph.graph.GraphConstants;

import javax.swing.tree.MutableTreeNode;
import javax.swing.*;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Point2D;
import java.awt.*;
import java.util.Map;
import java.util.Hashtable;

import manas.gui.DesignFrame;
import manas.MGates.MWire;

/**
 * Created by IntelliJ IDEA.
 * User: pc
 * Date: 22.Nis.2006
 * Time: 21:30:08
 * To change this template use File | Settings | File Templates.
 */
public class GSwitch extends DefaultGraphCell implements Simulation
{
    //private static int state;
    private int state = 0;
    private boolean isVisited;
    private MWire outWire;

    public boolean isVisited() {
        return isVisited;
    }

    public void setVisited(boolean visited) {
        isVisited = visited;
    }

    public void push(int index, MWire deger) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public MWire pop(int index) {
        return null;  //To change body of implemented methods use File | Settings | File Templates.
    }

    protected static ImageIcon CreateImageIcon(String path) {
            java.net.URL imgURL = DesignFrame.class.getResource(path);
            if (imgURL != null) {
                return new ImageIcon(imgURL);
            } else {
                System.err.println("Couldn't find file: " + path);
                    return null;
            }
        }

    public Map createCellAttributes(Point2D point, String path)
    {
        Map map = new Hashtable();
        ImageIcon icon = null;
/*    String iconPath = "images/andgate_small.gif";
    URL jgraphUrl = MainFrame.class.getClassLoader()
                            .getResource(iconPath);
    if(jgraphUrl == null) System.out.println("icon yok");
    icon = new ImageIcon(jgraphUrl);*/
        icon = CreateImageIcon(path);
        GraphConstants.setBounds(map, new Rectangle2D.Double(point.getX(), point.getY(), 20, 20));
        GraphConstants.setResize(map, true);
        GraphConstants.setSizeable(map, false);
        GraphConstants.setSelectable(map, true);
        GraphConstants.setEditable(map, false);
        GraphConstants.setIcon(map, icon);
        return map;
        }

    public GSwitch() {
        init();
    }

    public GSwitch(Object userObject) {
        super(userObject);
        init();
    }

    public GSwitch(Object userObject, AttributeMap storageMap) {
        super(userObject, storageMap);
        init();
    }

    public GSwitch(Object userObject, AttributeMap storageMap, MutableTreeNode[] children) {
        super(userObject, storageMap, children);
        init();
    }

    private void init()
    {
         // GraphConstants.setBounds(this.getAttributes(), new Rectangle2D.Double(30, 30, 50, 30));
        //this.addPort(new Point2D.Double(100,100));
         getAttributes().applyMap(createCellAttributes(new Point(10, 10),"images/switch.gif"));

       // GraphConstants.setBounds(this.getAttributes(), new Rectangle2D.Double(30, 30, 50, 30));
        //this.addPort(new Point(900,500));
        OutPort op = new OutPort();
        GraphConstants.setOffset(op.getAttributes(), new Point(900, 500));
        this.add(op);

        isVisited = false;
        outWire = new MWire();
        outWire.addWire(state);
    }

    public int changeState()
    {
        int ret;
        ImageIcon icon = null;

        ret = Math.abs(state - 1);
        state = ret;
        System.out.println(ret);
        if(ret == 0) icon = CreateImageIcon("images/switch.gif");
        else icon = CreateImageIcon("images/switch1.gif");
        GraphConstants.setIcon(this.getAttributes(), icon);
        return ret;
    }

    public MWire simulate() {
        outWire.setwire(0, state);
//        System.out.println("GSwitch state = " + state);
        if(isVisited == false)
        {
            System.out.println("GSitch e girdi");
            isVisited = true;
        }
        return outWire;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setInWire1(MWire inWire1) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setInWire2(MWire inWire2) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public MWire getOutWire() {
        return outWire;  //To change body of implemented methods use File | Settings | File Templates.
    }
}


