package manas.event;

import org.jgraph.JGraph;
import org.jgraph.graph.GraphModel;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;

/**
 * Created by IntelliJ IDEA.
 * User: EV
 * Date: 29.Oca.2006
 * Time: 15:38:30
 * To change this template use File | Settings | File Templates.
 */
public class DeleteDrawAction extends AbstractAction {
       JGraph graph;
    GraphModel model;
    List listEdges;
            public DeleteDrawAction()
            {

            }

        public DeleteDrawAction(JGraph gr)
        {
            this.graph = gr;
            model = graph.getModel();
        }

    public void actionPerformed(ActionEvent e) {

        if (!graph.isSelectionEmpty()) {
                    Object[] cells = graph.getSelectionCells();

                    for (int i = 0; i < cells.length; i++) {
                        Object cell = cells[i];
                        listEdges = new ArrayList();
                        int numChildren = model.getChildCount(cell);
                        for (int j = 0; j < numChildren; j++) {
                            Object port = model.getChild(cell, j);
                            if (model.isPort(port)) {
                                Iterator iter = model.edges(port);
                                while (iter.hasNext()) {
                                    listEdges.add(iter.next());
                                }
                            }
                        }
                    }
            System.out.println("Edge size = " + listEdges.size());
                    Object[] edges = listEdges.toArray();
                    edges = graph.getDescendants(edges);
                    model.remove(edges);

                    cells = graph.getDescendants(cells);
                    graph.getModel().remove(cells);
                }
    }
}
