package manas.event;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.*;
import java.awt.image.BufferedImage;

import java.io.FileOutputStream;
import java.io.File;

import javax.swing.filechooser.FileFilter;
import javax.imageio.ImageIO;

import com.lowagie.text.Document;
import com.lowagie.text.Image;
import com.lowagie.text.pdf.PdfWriter;
import org.jgraph.JGraph;


/**
 * Created by IntelliJ IDEA.
 * User: Serhat
 * Date: 22.Mar.2006
 * Time: 18:50:33
 * To change this template use File | Settings | File Templates.
 */
public class PrintPDFDrawAction extends AbstractAction {
    private JGraph   designInternalFrame1 ;

    public PrintPDFDrawAction(JGraph designInternalFrame)
    {
        this.designInternalFrame1 = designInternalFrame;
    }

    public void actionPerformed(ActionEvent e) {
       try{
           JFileChooser chooser = new JFileChooser();
           FileFilter filter = new javax.swing.filechooser.FileFilter() {
             public boolean accept(File f) {
               return f.isDirectory() || f.getName().toLowerCase().endsWith(".pdf");
                 }
             public String getDescription() {
                      return "PDF file";
                 }
           };

           chooser.setFileFilter(filter);

           int returnVal = chooser.showSaveDialog(null);

        if(returnVal == JFileChooser.APPROVE_OPTION)
        {
           // String filename = chooser.getSelectedFile().getName();
            String path = chooser.getSelectedFile().getAbsolutePath() + ".jpeg";
            String pathPDF = chooser.getSelectedFile().getAbsolutePath() + ".pdf";

            FileOutputStream fos = new FileOutputStream(path);
            Color bg = designInternalFrame1.getBackground();
            BufferedImage img = designInternalFrame1.getImage(bg, 40);
            ImageIO.write(img, "jpeg", fos);
            fos.flush();
            fos.close();
    // upto now i created jpeg and now i will embed this jpeg to pdf
            Document document = new Document();
            PdfWriter.getInstance(document, new FileOutputStream("" + pathPDF));
            document.open();
            Image jpg = Image.getInstance("" + path);
            document.add(jpg);
            document.close();
    // now delete jpg, its time is over :P
            boolean success = (new File("" + path)).delete();
                if (!success) {
                    System.out.println("deletion failed");
                }
        }

       } catch ( Exception ex ){
           ex.printStackTrace();
     }
   }
}
