package manas.event;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.io.*;

// DOM
import org.w3c.dom.*;
// Xerces classes.
import org.apache.xerces.dom.DocumentImpl;
import org.apache.xml.serialize.*;

import manas.GGates.*;

import java.awt.geom.Rectangle2D;
import org.jgraph.graph.*;
import org.jgraph.JGraph;

import java.lang.String;


/**
 * Created by IntelliJ IDEA.
 * User: Serhat
 * Date: 29.Oca.2006
 * Time: 15:34:15
 * To change this template use File | Settings | File Templates.
 */

//TODO Save ilemini daha general hale getiricem imdilik boyle  (Serhat)
    //-object array- control with loop


public class SaveDrawAction extends AbstractAction {
    private JGraph   designInternalFrame1 ;

    public SaveDrawAction(JGraph designInternalFrame) {

        this.designInternalFrame1 = designInternalFrame;

    }

    public void actionPerformed(ActionEvent e) {
        try {

        //MODEL
        GraphModel model = designInternalFrame1.getModel();

        //VERTICES
        Object a[] = designInternalFrame1.getGraphLayoutCache().getCells(false,true,false,false);

        int[] ID = new int[a.length];         //id of vertex
        String[] TYPE = new String[a.length]; //type of vertex
        double[] X = new double[a.length];    //x coordinate of vertex
        double[] Y = new double[a.length];    //y coordinate of vertex
        int[] PORT = new int[a.length];       //port number of vertex

        for (int i = 0; i < a.length; i++)
        {
            Object o = a[i];
            ID[i] = i;
             
            if(o instanceof GAnd)
            {
                TYPE[i] = "GAnd";
                Rectangle2D bnd = GraphConstants.getBounds(((GAnd)o).getAttributes());
                X[i] = bnd.getX();
                Y[i] = bnd.getY();
            }
            else if(o instanceof GNand)
            {
                ID[i] = i;
                TYPE[i] = "GNand";
                Rectangle2D bnd = GraphConstants.getBounds(((GNand)o).getAttributes());
                X[i] = bnd.getX();
                Y[i] = bnd.getY();
            }
            else if(o instanceof GNor)
            {
                ID[i] = i;
                TYPE[i] = "GNor";
                Rectangle2D bnd = GraphConstants.getBounds(((GNor)o).getAttributes());
                X[i] = bnd.getX();
                Y[i] = bnd.getY();
            }
            else if(o instanceof GNot)
            {
                ID[i] = i;
                TYPE[i] = "GNot";
                Rectangle2D bnd = GraphConstants.getBounds(((GNot)o).getAttributes());
                X[i] = bnd.getX();
                Y[i] = bnd.getY();
            }
            else if(o instanceof GOr)
            {
                ID[i] = i;
                TYPE[i] = "GOr";
                Rectangle2D bnd = GraphConstants.getBounds(((GOr)o).getAttributes());
                X[i] = bnd.getX();
                Y[i] = bnd.getY();
            }
            else if(o instanceof GXor)
            {
                ID[i] = i;
                TYPE[i] = "GXor";
                Rectangle2D bnd = GraphConstants.getBounds(((GXor)o).getAttributes());
                X[i] = bnd.getX();
                Y[i] = bnd.getY();
            }
            else if(o instanceof GSwitch)
            {
                ID[i] = i;
                TYPE[i] = "GSwitch";
                Rectangle2D bnd = GraphConstants.getBounds(((GSwitch)o).getAttributes());
                X[i] = bnd.getX();
                Y[i] = bnd.getY();
            }
            else if(o instanceof GLed)
            {
                ID[i] = i;
                TYPE[i] = "GLed";
                Rectangle2D bnd = GraphConstants.getBounds(((GLed)o).getAttributes());
                X[i] = bnd.getX();
                Y[i] = bnd.getY();
            }

            PORT[i] = model.getChildCount(o);
         }

         //EDGES --edge in points ozelligi var edge lerde port olacaksa burdan kotarrz (Serhat)
                      // addPoint le ekleriz pointleri.
         Object ae[] = designInternalFrame1.getGraphLayoutCache().getCells(false,false,false,true);
         int[] IDe = new int[ae.length];    //edge id
         int[] IDs = new int[ae.length];    //source vertex id
         int[] IDt = new int[ae.length];    //target vertex id
         int[] Ps = new int[ae.length];     //port number of the source port
         int[] Pt = new int[ae.length];     //port number of the target port

/*
         double[] Sx = new double[ae.length];   //source port coordinates(relative to the vertex)
         double[] Sy = new double[ae.length];
         double[] Tx = new double[ae.length];   //target port coordinates(relative to the vertex)
         double[] Ty = new double[ae.length];
*/
        for (int i = 0; i < ae.length; i++)
        {
            Object oe = ae[i];
            IDe[i] = i;

            DefaultPort SPort = ((DefaultPort)model.getSource(oe));    //Source port
            DefaultPort TPort = ((DefaultPort)model.getTarget(oe));    //Target port

            for(int j = 0; j < a.length; j++)
            {
                if(model.getParent(SPort).equals(a[j]))
                {
                    IDs[i] = j;
                }
                if(model.getParent(TPort).equals(a[j]))
                {
                    IDt[i] = j;
                }
            }
            //compute source port #
            for(int k = 0; k < model.getChildCount(model.getParent(SPort)); k++)
            {
                if(SPort.equals(model.getChild(model.getParent(SPort), k)))
                {
                    Ps[i] = k;
                }
            }
            //compute target port #
            for(int k = 0; k < model.getChildCount(model.getParent(TPort)); k++)
            {
                if(TPort.equals(model.getChild(model.getParent(TPort), k)))
                {
                    Pt[i] = k;
                }
            }
/*
            Point2D corS = GraphConstants.getOffset(SPort.getAttributes());
            Sx[i] = corS.getX();
            Sy[i] = corS.getY();

            Point2D corT = GraphConstants.getOffset(TPort.getAttributes());
            Tx[i] = corT.getX();
            Ty[i] = corT.getY();
*/
       //     System.out.println("IDs="+IDs[i]+", IDt="+IDt[i]);
       //     System.out.println("Ps="+Ps[i]+", Pt="+Pt[i]);
        }

        JFileChooser chooser = new JFileChooser();

         javax.swing.filechooser.FileFilter filter = new javax.swing.filechooser.FileFilter() {
            public boolean accept(File f) {
                        return f.isDirectory() || f.getName().toLowerCase().endsWith(".xml");
                    }
            public String getDescription() {
                        return "XML file";
                    }
        };

        chooser.setFileFilter(filter);

        int returnVal = chooser.showSaveDialog(null);

        if(returnVal == JFileChooser.APPROVE_OPTION)
        {
         //   String filename = chooser.getSelectedFile().getName();
            String path = chooser.getSelectedFile().getAbsolutePath()+ ".xml";

            Element elm;
           // Node n = null;
// Document (Xerces implementation only).
            Document xmldoc= new DocumentImpl();
// Root element.
            Element root = xmldoc.createElement("CELLS");
// Vertix element.
            Element vertix = xmldoc.createElement("VERTICES");
// Edge element.
            Element edge = xmldoc.createElement("EDGES");

            for (int i=0;i<a.length;i++)
            {
              elm = xmldoc.createElementNS(null, "VERTEX");
              elm.setAttributeNS(null, "ID", "" + ID[i]);
              elm.setAttributeNS(null, "TYPE", TYPE[i]);
              elm.setAttributeNS(null, "X", "" + X[i]);
              elm.setAttributeNS(null, "Y", "" + Y[i]);
              elm.setAttributeNS(null, "PORT", "" + PORT[i]);
//            n = xmldoc.createTextNode(desc[i]);
//            elm.appendChild(n);
              vertix.appendChild(elm);
            }
            root.appendChild(vertix);

            for (int i=0;i<ae.length;i++)
            {
              elm = xmldoc.createElementNS(null, "EDGE");
              elm.setAttributeNS(null, "ID", "" + IDe[i]);
              elm.setAttributeNS(null, "SOURCE_VERTEX_ID", "" + IDs[i]);
              elm.setAttributeNS(null, "TARGET_VERTEX_ID", "" + IDt[i]);
              elm.setAttributeNS(null, "SOURCE_PORT_NUMBER", "" + Ps[i]);
              elm.setAttributeNS(null, "TARGET_PORT_NUMBER", "" + Pt[i]);
//            n = xmldoc.createTextNode(desc[i]);
//            elm.appendChild(n);
              edge.appendChild(elm);
            }
            root.appendChild(edge);

            xmldoc.appendChild(root);


            FileOutputStream fos = new FileOutputStream(path);
// XERCES 1 or 2 additionnal classes.
            OutputFormat of = new OutputFormat("XML","ISO-8859-1",true);
            of.setIndent(1);
            of.setIndenting(true);
         //   of.setDoctype(null,"users.dtd");
            XMLSerializer serializer = new XMLSerializer(fos,of);
// As a DOM Serializer
            serializer.asDOMSerializer();
            serializer.serialize( xmldoc.getDocumentElement() );
            fos.close();
        }
      } catch ( Exception ex ) {
                    ex.printStackTrace();
      }

    }

}
