package manas.gui;

import javax.swing.*;
import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: EV
 * Date: 29.Oca.2006
 * Time: 15:13:45
 * To change this template use File | Settings | File Templates.
 */
public class DesignFrame extends JFrame {

    private DesignMenuBar designMenuBar;
    private DesignPopupMenu designPopupMenu = new DesignPopupMenu ();
    private DesignDesktopPane designDesktopPane;
    private DesignSymbolList designSymbolList;
    private DesignInternalFrame designInternalFrame;
    private DesignToolBar designToolBar;

    //private BorderLayout borderLayout = new BorderLayout();

    public DesignFrame(String title) throws HeadlessException {
        super(title);
        designInternalFrame = new DesignInternalFrame();
        designMenuBar = new DesignMenuBar(designInternalFrame.getDesignPanel());
        designDesktopPane = new DesignDesktopPane();
        designSymbolList = new DesignSymbolList (designInternalFrame.getDesignPanel());

        designToolBar = new DesignToolBar (designInternalFrame.getDesignPanel());
        this.setContentPane(designDesktopPane);
        //designMenuBar.setGraph(designInternalFrame.getDesignPanel());

        this.setJMenuBar(designMenuBar);
        designDesktopPane.add(designInternalFrame);
        designDesktopPane.add(designSymbolList);
        //this.add(designSymbolList);
        //this.setJMenuBar(designMenuBar);
       //this.add(designDesktopPane);
        this.setLayout(new BorderLayout());
        this.add(designToolBar, BorderLayout.NORTH);
    }
}
