package manas.gui;

import org.jgraph.graph.*;

import javax.swing.*;
import java.awt.*;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Arc2D;
import java.util.Vector;

import manas.GGates.GAnd;
import manas.event.MyMarqueeHandler;
import manas.simulation.Mapper;
import manas.simulation.Simulate;
import manas.MGates.MSuper;


/**
 * Created by IntelliJ IDEA.
 * User: EV
 * Date: 29.Oca.2006
 * Time: 15:16:30
 * To change this template use File | Settings | File Templates.
 */
public class DesignInternalFrame extends JInternalFrame {
    private DesignPanel designPanel;
    private DesignPopupMenu designPopupMenu;
    //private DesignFrame designFrame;
    private GraphLayoutCache graphLayoutCache = new GraphLayoutCache();
    private static int frameNo = 1;
    //DefaultGraphCell cells;
    private BasicMarqueeHandler myMarqueeHandler;
    private Vector<MSuper> devre;

/*
    public DesignInternalFrame(DesignPanel designPanel, DesignPopupMenu designPopupMenu) {
        super("Canvas #" + frameNo++, true, true, true, true);
        this.designPanel = designPanel;
        this.designPopupMenu = designPopupMenu;
        this.setSize(500, 500);
        this.setLocation(200,50);
        this.setVisible(true);
        this.moveToFront();

    }
*/
    public DesignInternalFrame()
    {
        super("Canvas #" + frameNo++, true, true, true, true);
        //designPanel = null;
        designPopupMenu = null;
        this.setSize(500, 500);
        this.setLocation(200,50);
        this.setVisible(true);
        this.moveToFront();
        //graphLayoutCache.setModel(new DefaultGraphModel());

        designPanel = new DesignPanel(new MyModel());
        myMarqueeHandler = new MyMarqueeHandler(designPanel);
        designPanel.setMarqueeHandler(myMarqueeHandler);
        //GraphConstants.setBounds(gand.getAttributes(), new Rectangle2D.Double(20, 20, 40, 20));
        //GraphConstants.setOpaque(gand.getAttributes(), true);
        //graphLayoutCache.insert(gand);
        //designPanel.setPortsVisible(true);
        // Control-drag should clone selection
/*		designPanel.setCloneable(true);

		// Enable edit without final RETURN keystroke
		designPanel.setInvokesStopCellEditing(true);

		// When over a cell, jump to its default port (we only have one, anyway)
		designPanel.setJumpToDefaultPort(true);

        cells = createVertex("hello", 20, 20, 40, 40, null, false);
        designPanel.getGraphLayoutCache().insert(cells);
*/
        this.add(new JScrollPane(designPanel));
        Simulate sim = new Simulate(designPanel, devre);
        Thread t1 = new Thread(sim);
        
        t1.start();
    }

    public DesignPanel getDesignPanel() {
        return designPanel;
    }

    public static DefaultGraphCell createVertex(String name, double x,
                                                double y, double w, double h, Color bg, boolean raised) {

        // Create vertex with the given name
        DefaultGraphCell cell = new DefaultGraphCell(name);

        // Set bounds
        GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double(
                x, y, w, h));

        // Set fill color
        if (bg != null) {
            GraphConstants.setGradientColor(cell.getAttributes(), Color.orange);
            GraphConstants.setOpaque(cell.getAttributes(), true);
        }

        // Set raised border
        if (raised)
            GraphConstants.setBorder(cell.getAttributes(), BorderFactory
                    .createRaisedBevelBorder());
        else
            // Set black border
            GraphConstants.setBorderColor(cell.getAttributes(), Color.black);

        // Add a Port
        DefaultPort port = new DefaultPort();
        cell.add(port);

        return cell;
    }
}
