package manas.gui;

import manas.event.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import org.jgraph.JGraph;

/**
 * Created by IntelliJ IDEA.
 * User: EV
 * Date: 29.Oca.2006
 * Time: 15:16:49
 * To change this template use File | Settings | File Templates.
 */
public class DesignMenuBar extends JMenuBar {
    JGraph graph;

    public JGraph getGraph() {
        return graph;
    }

    public void setGraph(JGraph graph) {
        this.graph = graph;
    }

    //File menu
    JMenu jMenuFile = new JMenu("File");
    //jMenuFile.setMnemonic(KeyEvent.VK_F);
    //jMenuFile.getAccessibleContext().setAccessibleDescription(
    //      "The only menu in this program that has menu items");

    //Edit menu
    JMenu jMenuEdit = new JMenu("Edit");

    //View menu
    JMenu jMenuView = new JMenu("View");

    //Tools menu
    JMenu jMenuTools = new JMenu("Tools");

    //Help menu
    JMenu jMenuHelp = new JMenu("Help");






    public DesignMenuBar(JGraph graph) {
        this.graph = graph;

         // JMenuFile items
    JMenuItem NewDrawMenuItem = new JMenuItem (new NewDrawAction ());
    JMenuItem OpenDrawMenuItem = new JMenuItem (new OpenDrawAction (graph));
    JMenuItem CloseDrawMenuItem = new JMenuItem (new CloseDrawAction ());
    JMenuItem SaveDrawMenuItem = new JMenuItem (new SaveDrawAction (graph));
    JMenuItem SaveAsDrawMenuItem = new JMenuItem (new SaveAsDrawAction (graph));
    JMenuItem SaveAsMacroDrawMenuItem = new JMenuItem (new SaveAsMacroDrawAction ());
    JMenuItem ExitDrawMenuItem = new JMenuItem (new ExitDrawAction ());
    JMenu jMenuFilePrint = new JMenu("Print...");
        JMenuItem PrintPDrawMenuItem = new JMenuItem (new PrintDrawAction (graph));
        JMenuItem PrintPSDrawMenuItem = new JMenuItem (new PrintPSDrawAction ());
        JMenuItem PrintPDFDrawMenuItem = new JMenuItem (new PrintPDFDrawAction (graph));
        JMenuItem PrintJPEGDrawMenuItem = new JMenuItem (new PrintJPEGDrawAction (graph));

    // JMenuEdit items
    JMenuItem UndoDrawMenuItem = new JMenuItem (new UndoDrawAction ());
    JMenuItem RedoDrawMenuItem = new JMenuItem (new RedoDrawAction ());
    JMenuItem CutDrawMenuItem = new JMenuItem (new CutDrawAction ());
    JMenuItem CopyDrawMenuItem = new JMenuItem (new CopyDrawAction ());
    JMenuItem PasteDrawMenuItem = new JMenuItem (new PasteDrawAction ());
    JMenuItem DeleteDrawMenuItem = new JMenuItem (new DeleteDrawAction (graph));

    // JMenuView items
    JMenuItem ZoomInDrawMenuItem = new JMenuItem (new ZoomInDrawAction ());
    JMenuItem ZoomOutDrawMenuItem = new JMenuItem (new ZoomOutDrawAction ());
    JMenuItem ToFrontDrawMenuItem = new JMenuItem (new ToFrontDrawAction ());
    JMenuItem ToBackDrawMenuItem = new JMenuItem (new ToBackDrawAction ());

    // JMenuTools items
    JMenuItem ScriptDrawMenuItem = new JMenuItem (new ScriptDrawAction ());
    JMenuItem LibraryDrawMenuItem = new JMenuItem (new LibraryDrawAction ());

    // JMenuHelp items
    JMenuItem TopicsDrawMenuItem = new JMenuItem (new TopicsDrawAction ());
    JMenuItem DocumentationDrawMenuItem = new JMenuItem (new DocumentationDrawAction ());
    JMenuItem WhatIsNewDrawMenuItem = new JMenuItem (new WhatIsNewDrawAction ());
    JMenuItem UpdateDrawMenuItem = new JMenuItem (new UpdateDrawAction ());
    JMenuItem AboutDrawMenuItem = new JMenuItem (new AboutDrawAction ());


     //*************KEYBOARD FACILITIES*************************
        jMenuFile.setMnemonic(KeyEvent.VK_F);
          NewDrawMenuItem.setMnemonic(KeyEvent.VK_N);
          OpenDrawMenuItem.setMnemonic(KeyEvent.VK_O);
            OpenDrawMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,Event.CTRL_MASK));
          CloseDrawMenuItem.setMnemonic(KeyEvent.VK_C);
          SaveDrawMenuItem.setMnemonic(KeyEvent.VK_S);
          SaveAsDrawMenuItem.setMnemonic(KeyEvent.VK_A);
          SaveAsMacroDrawMenuItem.setMnemonic(KeyEvent.VK_M);
          jMenuFilePrint.setMnemonic(KeyEvent.VK_P);
           PrintPDrawMenuItem.setMnemonic(KeyEvent.VK_R);
             PrintPDrawMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,Event.CTRL_MASK));
           PrintPSDrawMenuItem.setMnemonic(KeyEvent.VK_I);
           PrintPDFDrawMenuItem.setMnemonic(KeyEvent.VK_D);
           PrintJPEGDrawMenuItem.setMnemonic(KeyEvent.VK_J);
          ExitDrawMenuItem.setMnemonic(KeyEvent.VK_E);
            ExitDrawMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E,Event.CTRL_MASK));

        jMenuEdit.setMnemonic(KeyEvent.VK_E);
          UndoDrawMenuItem.setMnemonic(KeyEvent.VK_U);
            UndoDrawMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,Event.CTRL_MASK));
          RedoDrawMenuItem.setMnemonic(KeyEvent.VK_R);
            RedoDrawMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Y,Event.CTRL_MASK));
          CutDrawMenuItem.setMnemonic(KeyEvent.VK_T);
            CutDrawMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,Event.CTRL_MASK));
          CopyDrawMenuItem.setMnemonic(KeyEvent.VK_C);
            CopyDrawMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C,Event.CTRL_MASK));
          PasteDrawMenuItem.setMnemonic(KeyEvent.VK_V);
            PasteDrawMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V,Event.CTRL_MASK));
          DeleteDrawMenuItem.setMnemonic(KeyEvent.VK_D);
            DeleteDrawMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE,0));

        jMenuView.setMnemonic(KeyEvent.VK_V);
          ZoomInDrawMenuItem.setMnemonic(KeyEvent.VK_I);
          ZoomOutDrawMenuItem.setMnemonic(KeyEvent.VK_O);

        jMenuTools.setMnemonic(KeyEvent.VK_T);
          ScriptDrawMenuItem.setMnemonic(KeyEvent.VK_S);
           // ScriptDrawMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,Event.CTRL_MASK));
          LibraryDrawMenuItem.setMnemonic(KeyEvent.VK_L);

        jMenuHelp.setMnemonic(KeyEvent.VK_H);
          TopicsDrawMenuItem.setMnemonic(KeyEvent.VK_T);
          DocumentationDrawMenuItem.setMnemonic(KeyEvent.VK_D);
          WhatIsNewDrawMenuItem.setMnemonic(KeyEvent.VK_N);
          UpdateDrawMenuItem.setMnemonic(KeyEvent.VK_U);
          AboutDrawMenuItem.setMnemonic(KeyEvent.VK_A);



   //*****************MENU ADD*********************//
      // JMenuFile items
      this.add(jMenuFile);
        jMenuFile.add(NewDrawMenuItem);
        NewDrawMenuItem.setText("New");
          jMenuFile.add(OpenDrawMenuItem);
          OpenDrawMenuItem.setText("Open...");
          jMenuFile.add(CloseDrawMenuItem);
          CloseDrawMenuItem.setText("Close");
            jMenuFile.addSeparator();
          jMenuFile.add(SaveDrawMenuItem);
          SaveDrawMenuItem.setText("Save");
          jMenuFile.add(SaveAsDrawMenuItem);
          SaveAsDrawMenuItem.setText("Save As...");
          jMenuFile.add(SaveAsMacroDrawMenuItem);
          SaveAsMacroDrawMenuItem.setText("Save As Macro...");
            jMenuFile.addSeparator();
          jMenuFilePrint.add(PrintPDrawMenuItem);
          PrintPDrawMenuItem.setText("Print");
          jMenuFilePrint.add(PrintPSDrawMenuItem);
          PrintPSDrawMenuItem.setText("Print as PS");
          jMenuFilePrint.add(PrintPDFDrawMenuItem);
          PrintPDFDrawMenuItem.setText("Print as PDF");
          jMenuFilePrint.add(PrintJPEGDrawMenuItem);
          PrintJPEGDrawMenuItem.setText("Print as JPEG");
          jMenuFile.add(jMenuFilePrint);
            jMenuFile.addSeparator();
          jMenuFile.add(ExitDrawMenuItem);
          ExitDrawMenuItem.setText("Exit");

        // JMenuEdit items
        this.add(jMenuEdit);
          jMenuEdit.add(UndoDrawMenuItem);
          UndoDrawMenuItem.setText("Undo");
          jMenuEdit.add(RedoDrawMenuItem);
          RedoDrawMenuItem.setText("Redo");
           jMenuEdit.addSeparator();
          jMenuEdit.add(CutDrawMenuItem);
          CutDrawMenuItem.setText("Cut");
          jMenuEdit.add(CopyDrawMenuItem);
          CopyDrawMenuItem.setText("Copy");
          jMenuEdit.add(PasteDrawMenuItem);
          PasteDrawMenuItem.setText("Paste");
          jMenuEdit.add(DeleteDrawMenuItem);
          DeleteDrawMenuItem.setText("Delete");

        // JMenuView items
        this.add(jMenuView);
          jMenuView.add(ZoomInDrawMenuItem);
          ZoomInDrawMenuItem.setText("Zoom In");
          jMenuView.add(ZoomOutDrawMenuItem);
          ZoomOutDrawMenuItem.setText("Zoom Out");
            jMenuView.addSeparator();
          jMenuView.add(ToBackDrawMenuItem);
          ToBackDrawMenuItem.setText("Send to Back");
          jMenuView.add(ToFrontDrawMenuItem);
          ToFrontDrawMenuItem.setText("Bring to Front");


        // JMenuTools items
        this.add(jMenuTools);
          jMenuTools.add(ScriptDrawMenuItem);
          ScriptDrawMenuItem.setText("Script Console");
             jMenuTools.addSeparator();
          jMenuTools.add(LibraryDrawMenuItem);
          LibraryDrawMenuItem.setText("Library");

        // JMenuHelp items
        this.add(jMenuHelp);
          jMenuHelp.add(TopicsDrawMenuItem);
          TopicsDrawMenuItem.setText("Help Topics");
          jMenuHelp.add(DocumentationDrawMenuItem);
          DocumentationDrawMenuItem.setText("Online Documentation");
          jMenuHelp.add(WhatIsNewDrawMenuItem);
          WhatIsNewDrawMenuItem.setText("What is New");
          jMenuHelp.addSeparator();
          jMenuHelp.add(UpdateDrawMenuItem);
          UpdateDrawMenuItem.setText("Check for Update");
          jMenuHelp.add(AboutDrawMenuItem);
          AboutDrawMenuItem.setText("About");
    }
}