package manas.gui;

import manas.event.*;

import javax.swing.*;
import java.awt.Component.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.awt.event.ActionEvent;
import javax.swing.Action;

import org.jgraph.JGraph;


/**
 * Created by IntelliJ IDEA.
 * User: EV
 * Date: 29.Oca.2006
 * Time: 15:17:52
 * To change this template use File | Settings | File Templates.
 */
public class DesignSymbolList extends JInternalFrame {
    // static int openFrameCount = 0;
     //static final int xOffset = 5, yOffset = 5;
    JGraph graph1;

     protected static ImageIcon CreateImageIcon(String path) {
        java.net.URL imgURL = DesignFrame.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Couldn't find file: " + path);
                return null;
        }
    }
     public DesignSymbolList(JGraph graph) {
         super("Symbol Table",false, false, false, false)       ;

         this.graph1 = graph;


        final ImageIcon[] images;
        images = new ImageIcon[10];
        images[0] = CreateImageIcon("images/andgate.gif");
        images[1] = CreateImageIcon("images/orgate.gif");
        images[2] = CreateImageIcon("images/notgate.gif");
        images[3] = CreateImageIcon("images/nandgate.gif");
        images[4] = CreateImageIcon("images/norgate.gif");
        images[5] = CreateImageIcon("images/xorgate.gif");
        images[6] = CreateImageIcon("images/wire.gif");
        images[7] = CreateImageIcon("images/led.gif");
        images[8] = CreateImageIcon("images/switch.gif");
     // setLocation(xOffset*openFrameCount, yOffset*openFrameCount);
         this.setLayout(new GridLayout(3,1));
         JMenuBar mybar = new JMenuBar();

         JMenu jMenuSymbols = new JMenu("Symbols");
         JMenu jMenuOptions = new JMenu("Options");

         JMenuItem search = new JMenuItem(new SearchGate());
         JMenuItem list = new JMenuItem(new ListGates());
         JMenuItem dock = new JMenuItem(new DockSymbolTable());

         search.setText("Search");
         list.setText("List");
         dock.setText("Dock");



          String[] objeler = {"AND", "OR", "NOT", "NAND", "NOR", "XOR"};
          final JList symList = new  JList(objeler);


         //String AndGate = "\"<html><center><b><u>A</u>nd</b><br>\\\"\\n\" +\n" +
           //      "                 \"                 + Two Input And Gate,\\n\" +\n" +
             //    "                 \"                 Logical And...\"";

         final String[] AndGate = new String[]{"<html><left><u>AND</u><br>"
                 + "The  AND gate is a logic gate that gives an output of '1' only when all of its inputs are '1'.  Thus, its output is '0' whenever at least one of its inputs is '0'."};

         final JLabel lblDescription = new JLabel(AndGate[0]) ;

       //  lblDescription.setHorizontalTextPosition(JLabel.TOP);
         lblDescription.setVisible(true);

          final JLabel[] pictGate = new JLabel[]{new JLabel(images[0])};
         pictGate[0].setVisible(true);

         JLabel fit =  new JLabel();
         fit.setVisible(true);

         JScrollPane scrollPane = new JScrollPane(symList);
          jMenuSymbols.add(scrollPane)  ;
      //   jMenuSymbols.add(list);
         jMenuSymbols.add(search);
         jMenuOptions.add(dock);

         mybar.add(jMenuSymbols);
         mybar.add(jMenuOptions);
         mybar.setBounds(1,1,40,20);
         this.setJMenuBar(mybar);

         this.add(scrollPane) ;
         this.add(pictGate[0]);
         this.add(lblDescription);

         MouseListener mouseListener = new MouseAdapter() {
         public void mouseClicked(MouseEvent e) {
            if (e.getClickCount() == 2) {
                int index = symList.locationToIndex(e.getPoint());
                ActionEvent evt = new ActionEvent(e.getSource(), e.getID(), Action.ACTION_COMMAND_KEY);
                 Action act;
                      if(index == 0)
                            act = new AddAndAction(graph1);
                      else if(index == 1)
                            act = new AddOrAction(graph1);
                      else if(index == 2)
                            act = new AddNotAction(graph1);
                      else if(index == 3)
                            act = new AddNandAction(graph1);
                      else if(index == 4)
                            act = new AddNorAction(graph1);
                      else if(index == 5)
                            act = new AddXorAction(graph1);
                       else
                            act = new AddOrAction(graph1);
                  act.actionPerformed(evt);
              }

             if (e.getClickCount() == 1) {
                int index = symList.locationToIndex(e.getPoint());
                ActionEvent evt = new ActionEvent(e.getSource(), e.getID(), Action.ACTION_COMMAND_KEY);
                 Action act;
                      if(index == 0){
                            pictGate[0].setIcon(images[0]);
                            AndGate[0] = "<html><left><u>AND</u><br>"
                             + "The  AND gate is a logic gate that gives an output of '1' only when all of its inputs are '1'.  Thus, its output is '0' whenever at least one of its inputs is '0'.";
                            lblDescription.setText(AndGate[0]);
                      }
                      else if(index == 1)  {
                            pictGate[0].setIcon(images[1]);
                            AndGate[0] = "<html><left><u>OR</u><br>"
                             + "The  OR gate is a logic gate that gives an output of '0' only when all of its inputs are '0'. Thus, its output is '1' whenever at least one of its inputs is '1'.";
                            lblDescription.setText(AndGate[0]);
                      }
                      else if(index == 2)  {
                            pictGate[0].setIcon(images[2]);
                            AndGate[0] = "<html><left><u>NOT</u><br>"
                             + "The  NOT gate is a logic gate that gives an output that is opposite the state of its input.";
                            lblDescription.setText(AndGate[0]);
                      }
                      else if(index == 3)  {
                            pictGate[0].setIcon(images[3]);
                            AndGate[0] = "<html><left><u>NAND</u><br>"
                             + "The  NAND gate is an AND gate with a NOT gate at its end. Thus, for the same combination of inputs, the output of a NAND gate will be opposite that of an AND gate.";
                            lblDescription.setText(AndGate[0]);
                      }
                      else if(index == 4)  {
                            pictGate[0].setIcon(images[4]);
                            AndGate[0] = "<html><left><u>NOR</u><br>"
                             + "The  NOR gate is     an OR gate with a NOT gate at its end. Thus, for the same combination of inputs, the output of a NOR gate will be opposite that of an OR gate.";
                            lblDescription.setText(AndGate[0]);
                      }
                      else if(index == 5) {
                           pictGate[0].setIcon(images[5]);
                           AndGate[0] = "<html><left><u>XOR</u><br>"
                             + "The  EXOR gate  (for 'EXclusive OR' gate) is a logic gate that gives an output of '1' when only one of its inputs is '1'.";
                            lblDescription.setText(AndGate[0]);
                      }    /*
                       else{
                            pictGate[0].setIcon(images[0]);
                            AndGate[0] = "<html><left><u>AND</u><br>"
                             + "Description of AND Gate Starts"
                             + "Description of AND Gate Goes On"
                             + "Description of AND Gate Goes On"
                             + "Description of AND Gate Goes On"
                             + "Description of AND Gate Goes On"
                             + "Description of AND Gate Goes On";
                            lblDescription.setText(AndGate[0]);
                      }  */

              }

            }
        };
        symList.addMouseListener(mouseListener);






         setLocation(3,42)  ;
         setResizable(true);
         setSize(170,550);
         setVisible(true);
        // pack();

    }
}
