package manas.simulation;

import org.jgraph.JGraph;
import org.jgraph.graph.GraphModel;
import org.jgraph.graph.GraphConstants;
import manas.MGates.MSuper;
import manas.GGates.GAnd;
import manas.GGates.GLed;
import manas.GGates.OutPort;

import java.util.Vector;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

/**
 * Created by IntelliJ IDEA.
 * User: SahinBey
 * Date: 27.Nis.2006
 * Time: 19:04:19
 * To change this template use File | Settings | File Templates.
 */
public class Mapper {
    JGraph graph;
    MSuper devre;
    Vector<int[]> elementIndices;
    Vector<MSuper> subCircuit;
    Vector<Vector<MSuper>> mainCircuit;
    GraphModel model;

    public Mapper(JGraph graph, Vector<int[]> elementIndices) {
        this.graph = graph;
        this.model = graph.getModel();
        this.elementIndices = elementIndices;
        subCircuit = new Vector<MSuper>();
        mainCircuit = new Vector<Vector<MSuper>>();
    }

    public Mapper(JGraph graph) {
        this.graph = graph;
        this.model = graph.getModel();
        elementIndices = new Vector<int[]>();
        subCircuit = new Vector<MSuper>();
        mainCircuit = new Vector<Vector<MSuper>>();
        CircuitSplitter cs = new CircuitSplitter(graph);
        elementIndices = cs.extractAllCircuits();
    }

    public void join()
    {
        for (int i = 0; i < elementIndices.size(); i++) {
            int[] ints =  elementIndices.elementAt(i);

        }
    }

    private void parseGraph()
    {

    }
/********************** Simdilik deprecated ***************************************
    public int findRoot(Object node)
    {
        int rootNo;
        int portNo;
        int st;
        Object sibling = null;
        Object port;
        Object edge;
        List edges = new ArrayList();

        if(node == null) {
            System.out.println("node yok; Mapper.java - findRoot()");
        }
        portNo = getMaxPortNo(node);

        if(portNo <= 0) {
            System.out.println("node objesi cell degil; Mapper.java - findRoot()");
            return -1;
        }
        if(portNo == 1) return model.getIndexOfRoot(node);

        port = model.getChild(node, portNo);
        Iterator iter = model.edges(port);
        while(iter.hasNext())
            edges.add(iter.next());
        if(edges.size() == 0) return model.getIndexOfRoot(node);
        //TODO: burda alet ilk onune cian edge aliyo BUG olarak kayda geciyorum
        System.out.println("edge aliniyor ---- " + edges.size());
        edge = edges.get(0);
        System.out.println("edge alindi");
        st = isSourceOrTarget(edge, node);
        if(st == 1) sibling = model.getParent(model.getTarget(edge));
        else if(st == 2) sibling = model.getParent(model.getSource(edge));
        else {
            //System.out.println("node objesi edge ucunda degil; Mapper.java - findRoot()");
            return model.getIndexOfRoot(node);
        }
        rootNo = findRoot(sibling);
        return rootNo;
    }

    private int getMaxPortNo(Object node)
    {
        int portNo = 0;
        int childNo;       */
        /*
        if(model.isEdge(node) || model.isPort(node)) return -1;
        if(node instanceof GAnd) {
            portNo = 3;
        }
        */
    /*
        childNo = model.getChildCount(node);
        for (int i = 0; i < childNo; i++) {
            Object port = model.getChild(node, i);
            if(model.isPort(port)) portNo = i;
        }
        return portNo;
    }
**************************************************************************************************/
    //TODO: gecici olarak sunum cin bunu kullanacaz. Daha genis amacli bisey sonra yazariz
    public ArrayList findRoots(Object node)
    {
        ArrayList rootList = new ArrayList();
        int elemanlar = model.getRootCount();
        for(int i = 0; i < elemanlar; i++)
        {
            if(model.getRootAt(i) instanceof GLed) rootList.add(model.getRootAt(i));
        }
        return rootList;
    }

    public ArrayList findRoots2(Object node)
    {
        ArrayList rootList = new ArrayList();
        int elemanlar = model.getRootCount();
        for(int i = 0; i < elemanlar; i++)
        {
            Object vertex = model.getRootAt(i);
            int cc = model.getChildCount(vertex);
            for(int j = 0 ; j < cc; j++)
            {
                Object port = model.getChild(vertex, j);
                if(port instanceof OutPort)
                {
                    Iterator it = model.edges(port);
                    if(it.hasNext() == false) rootList.add(vertex);
                }
            }
        }
        return rootList;
    }

    private int isSourceOrTarget(Object edge, Object node)
    {
        Object eSource;
        Object eTarget;

        eSource = model.getSource(edge);
        eTarget = model.getTarget(edge);

        if(node.equals(eSource)) return 1;
        else if(node.equals(eTarget)) return 2;
        return -1;
    }
}
